capture log close
log using apptabD5.smcl, replace

*First stage models using alternative instruments, MSA level, only NELS MSAs;

#delimit;
version 8.0;
pause off;
set more off;
query;
creturn list;
clear;
set mem 64m;
set matsize 800;

do "../../definedirs.do";
quietly do "../moultonprog.do";


*Start with CD data;
 use ${hoxbydat_confidential}/achievement.regressions.dta, clear;
 global cd_ind "lnfaminc asian hispanic black female parcolg parscol";
 global cd_ma "mpop marea mlnincme mincgini mpctasia mpctblac mpcthisp mherfrac mherfeth mpctscol mpctcolg mherfed";
 global cd_dist "lnincmea incgini pctasia pctblac pcthisp herfrac herfeth pctscol pctcolg herfed";
 global cd_div "ddiv1 ddiv2 ddiv3 ddiv4 ddiv5 ddiv6 ddiv7 ddiv8";
 mark cd_samp;
 markout cd_samp $cd_ind $cd_ma $cd_dist $cd_div mchoienr f22xrstd f2wght;
 replace cd_samp=0 if f2wght<=0;
 replace cd_samp=0 if pubschf2~=1;
 keep if cd_samp==1;
 sort fipsmsa;
 keep fipsmsa cd_samp;
 by fipsmsa: keep if _n==1;
 sort fipsmsa;
 tempfile cd_msas;
 save `cd_msas';
 use ${hoxbydat_confidential}/firststage.regression.dta, clear;
 sort fipsmsa;
 merge fipsmsa using `cd_msas', unique _merge(mamrg);
 tab mamrg;
 drop mamrg;
 replace mpop=mpop/10000000;
 replace marea=marea/100000;
 regress mchoienr mnumrivr mnumstre mpop marea mlnincme mincgini mpctasia mpctblac mpcthisp mherfrac
                  mherfeth mpctscol mpctcolg mherfed
                  fs_div1 fs_div2 fs_div3 fs_div4 fs_div5 fs_div6 fs_div7 fs_div8 fs_div9 if cd_samp==1;
 test mnumrivr mnumstre;
 local p=r(p);
 local f=r(F);
 outreg using apptabD5.txt, replace bdec(8) rdec(8) se noparen noaster nolabel ctitle("CD_ivA")
        addstat("P-value", `p', "F-value", `f') adec(8);
 gen mnumstre_tot=mnumrivr+mnumstre;
 regress mchoienr mnumstre_tot mpop marea mlnincme mincgini mpctasia mpctblac mpcthisp mherfrac
                  mherfeth mpctscol mpctcolg mherfed
                  fs_div1 fs_div2 fs_div3 fs_div4 fs_div5 fs_div6 fs_div7 fs_div8 fs_div9 if cd_samp==1;
 test mnumstre_tot;
 local p=r(p);
 local f=r(F);
 outreg using apptabD5.txt, append bdec(8) rdec(8) se noparen noaster nolabel ctitle("CD_ivB")
        addstat("P-value", `p', "F-value", `f') adec(8);

*Now replication samples;
 *Prepare the data;
  use ${mywork_confidential}/chsample.dta, clear;
  global ch_ind "ch_lnfaminc ch_asian ch_hispanic ch_black ch_female ch_parcolg ch_parscol";
  global ch_ma "m_pop_n m_arealand ch_m_avglnmeaninc ch_m_gini ch_m_pop_fas ch_m_pop_fbl ch_m_pop_fhi ch_m_herfrace ch_m_herfethn m_ed_scol m_ed_ba m_herfed";
  global ch_dist "d_lnmeanincA ch_d_gini ch_d_pop_fas ch_d_pop_fbl ch_d_pop_fhi ch_d_herfrace ch_d_herfethn d_ed_scol d_ed_ba d_herfed";
  global ch_div "ch_d_div1 ch_d_div2 ch_d_div3 ch_d_div4 ch_d_div5 ch_d_div6 ch_d_div7 ch_d_div8";
  mark ch_samp;
  global ch_mdiv "ch_m_divis1 ch_m_divis2 ch_m_divis3 ch_m_divis4 ch_m_divis5 ch_m_divis6 ch_m_divis7 ch_m_divis8";
  markout ch_samp $ch_ind $ch_ma $ch_dist $ch_div ch_choice f22xrstd f2qwt;
  replace ch_samp=0 if f2qwt<=0;
  replace ch_samp=0 if pubschf2~=1;
  keep if ch_samp==1;
  sort fipsmsa;
  keep fipsmsa ch_samp;
  by fipsmsa: keep if _n==1;
  sort fipsmsa;
  tempfile ch_msas;
  save `ch_msas';
  use ${mywork_confidential}/jrAf2sample.dta, clear;
  global jr_ind "jr_lnfaminc jr_asian jr_hispanic jr_black jr_female jr_parcolg jr_parscol";
  global jr_ma "m_pop_n m_arealand m_lnmeanincA jr_m_gini jr_m_pop_fas jr_m_pop_fbl jr_m_pop_fhi jr_m_herfrace jr_m_herfethn m_ed_scol m_ed_ba m_herfed";
  global jr_dist "d_lnmeanincA jr_d_gini jr_d_pop_fas jr_d_pop_fbl jr_d_pop_fhi jr_d_herfrace jr_d_herfethn d_ed_scol d_ed_ba d_herfed";
  global jr_div "jr_m_divis1 jr_m_divis2 jr_m_divis3 jr_m_divis4 jr_m_divis5 jr_m_divis6 jr_m_divis7 jr_m_divis8 ";
  global jr_madiv "jr_m_divis1 jr_m_divis2 jr_m_divis3 jr_m_divis4 jr_m_divis5 jr_m_divis6 jr_m_divis7 jr_m_divis8 ";
  mark jr_samp;
  markout jr_samp $jr_ind $jr_ma $jr_dist $jr_div jr_choice f22xrstd f2qwt;
  replace jr_samp=0 if f2qwt<=0;
  replace jr_samp=0 if pubschf2~=1;
  keep if jr_samp==1;
  sort fipsmsa;
  keep fipsmsa jr_samp;
  by fipsmsa: keep if _n==1;
  sort fipsmsa;
  tempfile jr_msas;
  save `jr_msas';

  use ${mywork_public}/msadata.dta;
  sort fipsmsa;
  merge fipsmsa using `ch_msas', unique _merge(ch2msa);
  sort fipsmsa;
  merge fipsmsa using `jr_msas', unique _merge(jr2msa);
  tab ch2msa jr2msa, missing;

  local ivA "ch_nstreams_lg ch_nstreams_sm";
  local ivB "ch_nstreams_tot";
  local ivC "ch_nstreams_lg jr_nstreamsB_sm";
  local ivD "jr_nstreamsB_tot";
  local ivE "jr_nstreamsB_inter jr_nstreamsB_intra";
  local ivF "jr_nstreamsB_long jr_nstreamsB_short";
  gen jr_nstreamsB_sm=jr_nstreamsB_tot-ch_nstreams_lg;
  foreach l in A B C D E F {;
   reg ch_choice $ch_ma $ch_madiv `iv`l'' if ch_samp==1;
   test `iv`l'';
   local p=r(p);
   local f=r(F);
   outreg using apptabD5.txt, append bdec(8) rdec(8) se noparen noaster nolabel ctitle("CH_iv`l'")
          addstat("P-value", `p', "F-value", `f') adec(8);
  };
  foreach l in A B C D E F {;
   reg jr_choice $jr_ma $jr_madiv `iv`l'' if jr_samp==1;
   test `iv`l'';
   local p=r(p);
   local f=r(F);
   outreg using apptabD5.txt, append bdec(8) rdec(8) se noparen noaster nolabel ctitle("JR_iv`l'")
          addstat("P-value", `p', "F-value", `f') adec(8);
  };

log close;
