capture log close
log using apptabD6.smcl, replace

/* Two sample IV--use the whole sample of MSAs to estimate first stage, then put xhat into second stage equation*/

#delimit;
version 8.0;
pause off;
set more off;
query;
creturn list;
clear;
set mem 64m;
set matsize 800;

do "../../definedirs.do";
quietly do "../moultonprog.do";

*CD data;
 global xindivid "lnfaminc female asian black hispanic parscol parcolg";
 global xdistrict "lnincmea incgini pctasian pctblack pcthisp herfrace herfethn
                   pctscol pctcolg herfed";
 global xmetro "mpop marea mlnincme mincgini mpctasia mpctblac mpcthisp mherfrac
                mherfeth mpctscol mpctcolg mherfed";
 global xdivision "ddiv1 ddiv2 ddiv3 ddiv4 ddiv5 ddiv6 ddiv7 ddiv8 ddiv9";
 global xfsdivision "fs_div1 fs_div2 fs_div3 fs_div4 fs_div5 fs_div6 fs_div7 fs_div8 fs_div9";
 global xdistrict_nh "lnincmea pctasian pctblack pcthisp pctscol pctcolg";
 *First, figure out sample;
  use ${hoxbydat_confidential}/achievement.regressions.dta;
  ivreg by2xrstd $xindivid $xdistrict $xmetro $xdivision [aw=bywght] if pubschby==1, cluster(fipsmsa);
  gen cd_by=e(sample);
  replace cd_by=0 if cd_by==.;
  ivreg f22xrstd $xindivid $xdistrict $xmetro $xdivision [aw=f2wght] if pubschf2==1, cluster(fipsmsa);
  gen cd_f2=e(sample);
  replace cd_f2=0 if cd_f2==.;
  egen cd_sampby=max(cd_by), by(fipsmsa);
  egen cd_sampf2=max(cd_f2), by(fipsmsa);
  sort fipsmsa;
  by fipsmsa: keep if _n==1;
  keep fipsmsa cd_sampby cd_sampf2;
  tempfile cd_msasamp;
  save `cd_msasamp';
 *First stage;
  use ${hoxbydat_confidential}/firststage.regression.dta, clear;
  sort fipsmsa;
  merge fipsmsa using `cd_msasamp', uniqusing;
  regress mchoienr mnumrivr mnumstre $xmetro $xfsdivision;
  predict choicehatA_all, xb;
  regress mchoienr mnumrivr mnumstre $xmetro $xfsdivision if cd_sampby==1;
  predict choicehatA_by, xb;
  regress mchoienr mnumrivr mnumstre $xmetro $xfsdivision if cd_sampf2==1;
  predict choicehatA_f2, xb;
  keep fipsmsa choicehat* $xfsdivision;
  sort fipsmsa;
  keep if fipsmsa>0 & fipsmsa<.;
  tempfile cd_st1;
  save `cd_st1';
 *IV;
  use ${hoxbydat_confidential}/achievement.regressions.dta;
  keep if fipsmsa~=.;
  sort fipsmsa;
  merge fipsmsa using `cd_st1', uniqusing _merge(ma2ind);
  tab ma2ind;
  *Note: SEs are wrong;
  reg by2xrstd choicehatA_all $xindivid $xdistrict $xmetro $xfsdivision [aw=bywght] if pubschby==1, cluster(fipsmsa);
  outreg using apptabD6.txt, replace bdec(8) rdec(8) se noparen noaster nolabel ctitle("CD_by_Aall");
  reg by2xrstd choicehatA_by $xindivid $xdistrict $xmetro $xfsdivision [aw=bywght] if pubschby==1, cluster(fipsmsa);
  outreg using apptabD6.txt, append bdec(8) rdec(8) se noparen noaster nolabel ctitle("CD_by_Aby");
  reg f22xrstd choicehatA_all $xindivid $xdistrict $xmetro $xfsdivision [aw=f2wght] if pubschf2==1, cluster(fipsmsa);
  outreg using apptabD6.txt, append bdec(8) rdec(8) se noparen noaster nolabel ctitle("CD_f2_Aall");
  reg f22xrstd choicehatA_f2 $xindivid $xdistrict $xmetro $xfsdivision [aw=f2wght] if pubschf2==1, cluster(fipsmsa);
  outreg using apptabD6.txt, append bdec(8) rdec(8) se noparen noaster nolabel ctitle("CD_f2_Af2");

*Replication data;
  global ch_ind "ch_lnfaminc ch_asian ch_hispanic ch_black ch_female ch_parcolg ch_parscol";
  global ch_ma "m_pop_n m_arealand ch_m_avglnmeaninc ch_m_gini ch_m_pop_fas ch_m_pop_fbl ch_m_pop_fhi ch_m_herfrace ch_m_herfethn m_ed_scol m_ed_ba m_herfed";
  global ch_dist "d_lnmeanincA ch_d_gini ch_d_pop_fas ch_d_pop_fbl ch_d_pop_fhi ch_d_herfrace ch_d_herfethn d_ed_scol d_ed_ba d_herfed";
  global ch_div "ch_d_div1 ch_d_div2 ch_d_div3 ch_d_div4 ch_d_div5 ch_d_div6 ch_d_div7 ch_d_div8";
  global ch_mdiv "ch_m_divis1 ch_m_divis2 ch_m_divis3 ch_m_divis4 ch_m_divis5 ch_m_divis6 ch_m_divis7 ch_m_divis8";
 *First, figure out sample;
  *CH data;
   use if fipsmsa<. & fipsmsa>0 using ${mywork_confidential}/chsample.dta, clear;
   mark ch_cntrls;
   markout ch_cntrls $ch_ind $ch_ma $ch_dist $ch_div ch_choice;
   gen ivsampA=1 if ch_nstreams_lg<. & ch_nstreams_sm<.;
   gen ivsampB=1 if jr_nstreamsB_inter<. & jr_nstreamsB_intra<.;
   gen sampAby=1 if byqwt>0 & ch_cntrls==1 & pubschby==1 & by2xrstd<. & ivsampA==1;
   gen sampBby=1 if byqwt>0 & ch_cntrls==1 & pubschby==1 & by2xrstd<. & ivsampB==1;
   gen sampAf2=1 if f2qwt>0 & ch_cntrls==1 & pubschf2==1 & f22xrstd<. & ivsampA==1;
   gen sampBf2=1 if f2qwt>0 & ch_cntrls==1 & pubschf2==1 & f22xrstd<. & ivsampB==1;
   foreach v of varlist sampAby sampBby sampAf2 sampBf2 {;
    replace `v'=0 if `v'~=1;
    egen ch_`v'=max(`v'), by(fipsmsa);
    };
   keep fipsmsa ch_samp*;
   sort fipsmsa;
   by fipsmsa: keep if _n==1;
   sort fipsmsa;
   tempfile chsamp;
   save `chsamp';
  *JR data;
   use if fipsmsa<. & fipsmsa>0 using ${mywork_confidential}/jrAbysample.dta;
   mark jr_cntrls;
   markout jr_cntrls $jr_ind $jr_ma $jr_dist $jr_div jr_choice;
   gen ivsampA=1 if ch_nstreams_lg<. & ch_nstreams_sm<.;
   gen ivsampB=1 if jr_nstreamsB_inter<. & jr_nstreamsB_intra<.;
   gen sampAby=1 if byqwt>0 & jr_cntrls==1 & pubschby==1 & by2xrstd<. & ivsampA==1;
   gen sampBby=1 if byqwt>0 & jr_cntrls==1 & pubschby==1 & by2xrstd<. & ivsampB==1;
   foreach v of varlist sampAby sampBby {;
    replace `v'=0 if `v'~=1;
    egen jr_`v'=max(`v'), by(fipsmsa);
    };
   keep fipsmsa jr_samp*;
   sort fipsmsa;
   by fipsmsa: keep if _n==1;
   sort fipsmsa;
   tempfile jrsampby;
   save `jrsampby';
   use if fipsmsa<. & fipsmsa>0 using ${mywork_confidential}/jrAf2sample.dta;
   mark jr_cntrls;
   markout jr_cntrls $jr_ind $jr_ma $jr_dist $jr_div jr_choice;
   gen ivsampA=1 if ch_nstreams_lg<. & ch_nstreams_sm<.;
   gen ivsampB=1 if jr_nstreamsB_inter<. & jr_nstreamsB_intra<.;
   gen sampAf2=1 if f2qwt>0 & jr_cntrls==1 & pubschf2==1 & f22xrstd<. & ivsampA==1;
   gen sampBf2=1 if f2qwt>0 & jr_cntrls==1 & pubschf2==1 & f22xrstd<. & ivsampB==1;
   foreach v of varlist sampAf2 sampBf2 {;
    replace `v'=0 if `v'~=1;
    egen jr_`v'=max(`v'), by(fipsmsa);
    };
   keep fipsmsa jr_samp*;
   sort fipsmsa;
   by fipsmsa: keep if _n==1;
   sort fipsmsa;
   tempfile jrsampf2;
   save `jrsampf2';
 *Now go to the MSA-level data to estimate the first stage;
  use ${mywork_public}/msadata.dta;
  sort fipsmsa;
  merge fipsmsa using `chsamp', unique _merge(mrg1);
  sort fipsmsa;
  merge fipsmsa using `jrsampby', unique _merge(mrg2);
  sort fipsmsa;
  merge fipsmsa using `jrsampf2', unique _merge(mrg3);
  local ivA "ch_nstreams_lg ch_nstreams_sm";
  local ivB "jr_nstreamsB_inter jr_nstreamsB_intra";
  foreach l in A B {;
   reg ch_choice $ch_ma $ch_madiv `iv`l'';
   predict ch_choicehat`l'_all;
   reg ch_choice $ch_ma $ch_madiv `iv`l'' if ch_samp`l'by==1;
   predict ch_choicehat`l'_by;
   reg ch_choice $ch_ma $ch_madiv `iv`l'' if ch_samp`l'f2==1;
   predict ch_choicehat`l'_f2;
   reg jr_choice $jr_ma $jr_madiv `iv`l'';
   predict jr_choicehat`l'_all;
   reg jr_choice $jr_ma $jr_madiv `iv`l'' if jr_samp`l'by==1;
   predict jr_choicehat`l'_by;
   reg jr_choice $jr_ma $jr_madiv `iv`l'' if jr_samp`l'f2==1;
   predict jr_choicehat`l'_f2;
  };
  keep fipsmsa *choicehat*;
  sort fipsmsa;
  tempfile choicehat;
  save `choicehat';
 *Finally, back to the indiv-level data, for second stage;
  use ${mywork_confidential}/chsample;
  sort fipsmsa;
  merge fipsmsa using `choicehat', uniqusing;
  mark chsamp;
  markout chsamp $ch_ind $ch_ma $ch_dist $ch_div ch_choice;
  gen samp_by=1 if byqwt>0 & chsamp==1 & pubschby==1 & by2xrstd<.;
  egen totwgt_by=sum(byqwt) if samp_by==1, by(fipsmsa);
  gen wgt_by=byqwt/totwgt_by if samp_by==1;
  foreach l in A B {;
   reg by2xrstd ch_choicehat`l'_all $ch_ind $ch_ma $ch_dist $ch_div [aw=wgt_by], cluster(fipsmsa);
   outreg using apptabD6.txt, append bdec(8) rdec(8) se noparen noaster nolabel ctitle("CH_by_`l'all");
   reg by2xrstd ch_choicehat`l'_by $ch_ind $ch_ma $ch_dist $ch_div [aw=wgt_by], cluster(fipsmsa);
   outreg using apptabD6.txt, append bdec(8) rdec(8) se noparen noaster nolabel ctitle("CH_by_`l'by");
  };
  gen samp_f2=1 if f2qwt>0 & chsamp==1 & pubschf2==1 & f22xrstd<.;
  egen totwgt_f2=sum(f2qwt) if samp_f2==1, by(fipsmsa);
  gen wgt_f2=f2qwt/totwgt_f2 if samp_f2==1;
  foreach l in A B {;
   reg f22xrstd ch_choicehat`l'_all $ch_ind $ch_ma $ch_dist $ch_div [aw=wgt_f2], cluster(fipsmsa);
   outreg using apptabD6.txt, append bdec(8) rdec(8) se noparen noaster nolabel ctitle("CH_f2_`l'all");
   reg f22xrstd ch_choicehat`l'_f2 $ch_ind $ch_ma $ch_dist $ch_div [aw=wgt_f2], cluster(fipsmsa);
   outreg using apptabD6.txt, append bdec(8) rdec(8) se noparen noaster nolabel ctitle("CH_f2_`l'f2");
   };
  use ${mywork_confidential}/jrAbysample, clear;
  sort fipsmsa;
  merge fipsmsa using `choicehat', uniqusing;
  mark jrsamp;
  markout jrsamp $jr_ind $jr_ma $jr_dist $jr_div jr_choice;
  gen samp_by=1 if byqwt>0 & jrsamp==1 & pubschby==1 & by2xrstd<.;
  egen totwgt_by=sum(byqwt) if samp_by==1, by(fipsmsa);
  gen wgt_by=byqwt/totwgt_by if samp_by==1;
  foreach l in A B {;
   reg by2xrstd jr_choicehat`l'_all $jr_ind $jr_ma $jr_dist $jr_div [aw=wgt_by], cluster(fipsmsa);
   outreg using apptabD6.txt, append bdec(8) rdec(8) se noparen noaster nolabel ctitle("JR_by_`l'all");
   reg by2xrstd jr_choicehat`l'_by $jr_ind $jr_ma $jr_dist $jr_div [aw=wgt_by], cluster(fipsmsa);
   outreg using apptabD6.txt, append bdec(8) rdec(8) se noparen noaster nolabel ctitle("JR_by_`l'by");
  };
  use ${mywork_confidential}/jrAf2sample, clear;
  sort fipsmsa;
  merge fipsmsa using `choicehat', uniqusing;
  mark jrsamp;
  markout jrsamp $jr_ind $jr_ma $jr_dist $jr_div jr_choice;
  gen samp_f2=1 if f2qwt>0 & jrsamp==1 & pubschf2==1 & f22xrstd<.;
  egen totwgt_f2=sum(f2qwt) if samp_f2==1, by(fipsmsa);
  gen wgt_f2=f2qwt/totwgt_f2 if samp_f2==1;
  foreach l in A B {;
   reg f22xrstd jr_choicehat`l'_all $jr_ind $jr_ma $jr_dist $jr_div [aw=wgt_f2], cluster(fipsmsa);
   outreg using apptabD6.txt, append bdec(8) rdec(8) se noparen noaster nolabel ctitle("JR_f2_`l'all");
   reg f22xrstd jr_choicehat`l'_f2 $jr_ind $jr_ma $jr_dist $jr_div [aw=wgt_f2], cluster(fipsmsa);
   outreg using apptabD6.txt, append bdec(8) rdec(8) se noparen noaster nolabel ctitle("JR_f2_`l'f2");
  };

log close;
